{
  
   Project  : ODGE
   Unit Name: uodge_main

 /--------------------------------------------------------------\
 | Purpose    : MAIN PROPERTY EDITOR WINDOW (+ register prop ed)|
 | Author     : Olivier DAHAN 100531.163@compuserve.com         |
 +--------------------------------------------------------------+
 | History    : V 1.0 Apr 4th 98                                |
 |              V 1.1 Apr 17th 98 (debug, blinking focus)       |
 |              V 1.2 Apr 19th 98 (image rotate, ->gray...)     |
 | Created on : 04/04/98 02:08:16                               |
 \--------------------------------------------------------------/

 THIS SOFTWARE USE IS FREE BUT I KEEP MY COPYRIGHT :
 You can't use it but for personnal needs. Else you need my
 written authorization (depending on what you offer in exchange).

 IT'S FREE, YOU'VE GOT THE SOURCE CODE : ASK NO SUPPORT ...
 BEFORE USING THIS SOFTWARE YOU MUST AGREE THE LICENSE TERMS
 (see help file).

 Of course, after this legal stuff, if you have some questions about
 this software, I'll be glad to answer you...
 Please note: If you downloaded this software, it is certainly not
 accidental, you certainly use to visit Delphi Super Page, Delphi Deli,
 Torry's page and others Delphi Web sites. So, next time you'll be connected,
 think about a little message for me saying you use this soft.

 EVERY USES SENDING A FREE REGISTER MESSAGE (Name, company, address, email,
 comments about this software) WILL RECEIVE ANOTHER FREE DELPHI CODE BY EMAIL.

}

unit uodge_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  myff, StdCtrls, FileCtrl, ExtCtrls, ColorGrd, Buttons, Spin, clipbrd,
  registry, Menus,typinfo,dsgnintf, ExtDlgs, Math, Placemnt;



type

  // Property Editor Class
  TODGEProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TODGEGType = (odge_none,odge_Picture, odge_Icon, odge_Bitmap);

  TFODGEMain = class(TForm)
    MyFF1: TMyFF;
    Panel2: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Panel3: TPanel;
    BitBtn1: TBitBtn;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Bevel1: TBevel;
    BitBtn2: TBitBtn;
    SpeedButton4: TSpeedButton;
    Panel4: TPanel;
    Panel5: TPanel;
    SpinEdit1: TSpinEdit;
    Splitter2: TSplitter;
    Panel7: TPanel;
    Panel6: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    ListBox1: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    cb1: TComboBox;
    Splitter3: TSplitter;
    Panel1: TPanel;
    Image2: TImage;
    Panel8: TPanel;
    CheckBox1: TCheckBox;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    DriveComboBox1: TDriveComboBox;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    Panel9: TPanel;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    PopupMenu1: TPopupMenu;
    Refresh1: TMenuItem;
    opd1: TOpenPictureDialog;
    spd1: TSavePictureDialog;
    SpeedButton14: TSpeedButton;
    PopupMenu2: TPopupMenu;
    Filecount1: TMenuItem;
    PopupMenu3: TPopupMenu;
    Device1: TMenuItem;
    N1bit1: TMenuItem;
    N4bit1: TMenuItem;
    N8bit1: TMenuItem;
    N15bit1: TMenuItem;
    N16bit1: TMenuItem;
    N24bit1: TMenuItem;
    N32bit1: TMenuItem;
    Custom1: TMenuItem;
    N1: TMenuItem;
    EditImage1: TMenuItem;
    Timer1: TTimer;
    Converttogray1: TMenuItem;
    Rotate1: TMenuItem;
    FormPlacement1: TFormPlacement;
    procedure MyFF1AddFile(path: String; data: TWin32FindDataA;
      var cancel: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure MyFF1ChDir(name: String; var cancel: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpinEdit1Change(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure SpeedButton16Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure cb1Change(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure Filecount1Click(Sender: TObject);
    procedure PopupMenu3Popup(Sender: TObject);
    procedure PxiFmtChange(Sender: TObject);
    procedure EditImage1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Converttogray1Click(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
  private
    { Dclarations prives }
    ftype : TODGEGType;
    fcolcount :integer;
    fRowCount : integer;
    fRowHeight :integer;
    fColWidth :integer;
    fBoard : TBitmap;
    Updating:boolean;
    fdrawhz,
    fdrawvt : boolean;
    flinecolor,ffocuscolor:tcolor;
    flastidx:integer;
    fnegfoc : boolean;
    fQuickpath : TStringList;
    fQuickmode : Boolean;
    fMustSave : Boolean;
    fcreating : boolean;
    flastloaddir:string;
    fpix : TPixelFormat;
    fcopythr : integer;
    fcopystretch:boolean;
    fcounter:integer;
    ffocused : boolean;
    fLastFocused:Trect;
    fPicEditor:string;
    fPageFile:String;
    fpause:integer;
    fokblink:boolean;
    flastblink:trect;
    fblinkfocus:boolean;
    fblinkrate:integer;
    fLastPicWH : Tpoint;
    procedure SetColCount(value:integer);
    function getcolcount:integer;
    procedure SetRowCount(value:integer);
    function getrowcount:integer;
    function getCellCount:integer;
    procedure SetRowHeight(value:integer);
    Procedure SetColWidth(value:integer);
    function getRowHeight:integer;
    function getColWidth:integer;
    Function GetIndexForCR(Col,Row:integer):Integer;
    Function GetCRForIndex(Idx:integer):TPoint;
    Function GetCurrentPath:String;
    procedure SetType(value:TodgeGtype);
    procedure RefreshGraph;
    Function ComputeRecForIndex(idx:integer):TRect;
    procedure setdrawvt(value:boolean);
    procedure setdrawhz(value:boolean);
    procedure setlinecolor(value:tcolor);
    procedure dfoc(r:trect);
    procedure Synchrocb1;
    procedure loadcb1;
    Procedure SaveCurrentPage;
    Function LoadCurrentPage:Boolean;
    procedure CutEvents;
    procedure RecoverEvents;
    Procedure LoadImgRegistry;
    procedure SetBlinkFocus(value:boolean);
    procedure SetBlinkRate(value:integer);
    procedure ClearScrollBox;
    procedure UpdateButtons;
  public
    { Dclarations publiques }
    Property ColCount : Integer read GetColCOunt write SetColCOunt;
    Property RowCount : integer read GetRowCount write setrowcount;
    Property CellCount: integer read getCellCount;
    Property RowHeight: integer read GetRowHeight write SetRowHeight;
    Property ColWidth : integer read GetColWidth write SetColWidth;
    Property CurrentPath : string read GetCurrentpath;
    Property GraphType : TODGEGtype read fType write SetType;
    Property DrawHZ : boolean read fdrawhz write setdrawhz;
    Property DrawVT : boolean read fdrawvt write setdrawvt;
    Property LineColor : Tcolor read flinecolor write setlinecolor;
    Property BlinkingFocus:Boolean read fblinkfocus write setblinkfocus;
    property BlinkingRate:integer read fblinkrate write setblinkrate;
  end;

Procedure Register;


var FODGEMAIN: TFODGEMain;
implementation

uses uodge_fullsize, uodge_updgauge, uodge_quickpath, uodge_options,
  uodge_about, Crc2;

// Registry key for ODGE
const SoftKey = '\software\ODGlyphPropEd';

{$R *.DFM}

//-----------------------------------------------------------
// TODGEProperty.Edit : call main dialog from Delphi IDE
//-----------------------------------------------------------
Procedure TODGEProperty.Edit;
var
  ImageDialog: TFODGEMain;
  Picture:TPicture;
begin
  ImageDialog := TFODGEMain.Create(Application);
  try
    Picture:=TPicture(GetOrdValue);
    ImageDialog.Image2.Picture := Picture;
    if (GetPropType^.Name = 'TPicture') then
      ImageDialog.GraphType := odge_picture
        else if (GetPropType^.Name = 'TIcon') then
          ImageDialog.GraphType := odge_icon
            else ImageDialog.GraphType := odge_bitmap;

    if ImageDialog.ShowModal=mrOk then
    begin
     if (GetPropType^.Name = 'TPicture') then
         SetOrdValue(LongInt(ImageDialog.Image2.Picture))
           else if (GetPropType^.Name = 'TIcon') then
             SetOrdValue(LongInt(ImageDialog.Image2.Picture.Icon))
               else SetOrdValue(LongInt(ImageDialog.Image2.Picture.Bitmap));
    end;
  finally
    ImageDialog.Release;
  end;
end;

//-----------------------------------------------------------
// TODGEProperty.GetAttributes : property editor attributes
//-----------------------------------------------------------
Function TODGEProperty.GetAttributes : TPropertyAttributes;
begin
 Result := [paDialog, paReadOnly];
end;


// dummy class used to save/load bitmap of glyphs
type
TInternalObject = Class (TComponent)
                  private
                  fpicture:Tpicture;
                  flist : TStrings;
                  fcolwidth : integer;
                  frowheight: integer;
                  fcolcount:integer;
                  fdrawhz, fdrawvt : boolean;
                  flinecolor : tcolor;
                  fdir : string;
                  fpixf : tpixelformat;
                  fcopys:boolean;
                  fcopyt:integer;
                  procedure SetPicture(value:Tpicture);
                  procedure setlist(value:TStrings);
                  public
                  Constructor Create(Aowner:Tcomponent); override;
                  Destructor destroy; override;
                  Published
                  Property Image : TPicture read fpicture write Setpicture;
                  Property FileList : TStrings read flist write setlist;
                  property ColWidth : integer read fcolwidth write fcolwidth;
                  property RowHeight : integer read frowheight write frowheight;
                  property colcount  : integer read fcolcount write fcolcount;
                  property DrawHz : boolean read fDrawhz write fDrawHz;
                  property drawVt : boolean read fdrawvt write fdrawvt;
                  property lineColor : tcolor read flinecolor write flinecolor;
                  property Directory : string read fdir write fdir;
                  property PixelF : TPixelFormat read fpixf write fpixf;
                  property CopyStretch:boolean read fcopys write fcopys;
                  property COpyThreshold:integer read fcopyt write fcopyt;
                  end;


//-----------------------------------------------------------
// TinternalObject.Create : constructor for internal object
//-----------------------------------------------------------
Constructor TinternalObject.Create(Aowner:TComponent);
begin
 Inherited create(aowner);
 fpicture := Tpicture.create;
 flist := TStringlist.Create;
end;

//-----------------------------------------------------------
// TinternalObject.Destroy : destructor for internal object
//-----------------------------------------------------------
Destructor TinternalObject.Destroy;
begin
 fpicture.free;
 flist.free;
 inherited destroy;
end;

//-----------------------------------------------------------
// TInternalObject.SetPicture
//-----------------------------------------------------------
Procedure TInternalObject.SetPicture(value:Tpicture);
begin
 fpicture.assign(value);
end;

//-----------------------------------------------------------
// TInternalObject.Setlist
//-----------------------------------------------------------
Procedure TInternalObject.Setlist(value:TStrings);
begin
 flist.assign(value);
end;

// ********* MAIN **********


//-----------------------------------------------------------
// ComputeRecForIndex : returns a Trect for linear index Idx
//-----------------------------------------------------------
Function TFODGEMain.ComputeRecForIndex(idx:integer) :Trect;
var pp:tpoint;
begin
 pp := GetCRForIndex(idx);
 result.Left := (pp.x*(ColWidth+2))+1;
 result.Right := Result.left+ColWidth-1;
 result.top := (pp.y*(rowHeight+2))+1;
 result.Bottom := Result.top+Rowheight-1;
end;


//-----------------------------------------------------------
// SetBlinkFocus : set blinking focused rect on/off
//-----------------------------------------------------------
procedure TFODGEMain.SetBlinkFocus(value:boolean);
begin
 if value<> fblinkfocus then
  begin
   fblinkfocus:=value;
   timer1.Enabled := fblinkfocus;
  end;
end;

//-----------------------------------------------------------
// SetBlinkrate : blink timer delay
//-----------------------------------------------------------
procedure TFODGEMain.SetBlinkrate(value:Integer);
begin
 if value<> fblinkrate then
  begin
   fblinkrate:=value;
   timer1.Interval := value;
  end;
end;


//------------------------------------------------------------
// Refreshgraph : recreate the main bitmap from glyphs on disk
//------------------------------------------------------------
Procedure TFODGEMain.Refreshgraph;
var i:integer; p:tpicture; dr,sr:TRect; f:tfODGEupdgauge;
begin
 if Updating then exit;
 if LoadCurrentPage then exit;
 if Listbox1.Items.count=0 then
  begin
   Image1.Picture := nil;
   ClearScrollbox;
   exit;
  end;
 Screen.Cursor := crHourGlass;
 f:=TfODGEUpdGauge.Create(self);
 f.show;
 f.Refresh;
 try
  fboard.Free;
  fboard:=Tbitmap.create;
  fboard.PixelFormat := fpix;
  fBoard.Width := ColCount * (ColWidth+2);
  fBoard.height := RowCount * (Rowheight+2);
  fboard.Canvas.brush.color := clwindow;
  fboard.Canvas.FillRect(rect(0,0,fboard.width,fboard.height));
  p:=tpicture.Create;
  f.ProgressBar1.Min :=-1;
  f.ProgressBar1.Max := listbox1.Items.Count-1;
  f.ProgressBar1.Position :=0;
  try
   for i:=0 to Listbox1.items.count-1 do
    begin
     p.LoadFromFile(CurrentPath+Listbox1.items[i]);
     dr := ComputeRecForIndex(i);
     if Ansicomparetext(extractfileext(Listbox1.items[i]),'.BMP')=0 then
      begin
       if fcopystretch then sr:=rect(0,0,p.width,p.height)
                       else sr:=rect(0,0,colwidth,rowheight);
       if p.height>fcopythr then fBoard.canvas.CopyRect(dr,p.bitmap.canvas,sr) else
        fBoard.canvas.BrushCopy(dr,p.Bitmap,rect(0,0,p.width,p.height),p.bitmap.Canvas.Pixels[0,0]);
      end;
     if Ansicomparetext(extractfileext(Listbox1.items[i]),'.ICO')=0 then
      fBoard.canvas.draw(dr.left,dr.Top,p.icon);
     if Ansicomparetext(extractfileext(Listbox1.items[i]),'.WMF')=0 then
      fBoard.canvas.draw(dr.left,dr.Top,p.Metafile);
     f.ProgressBar1.Position := i;
     f.ProgressBar1.Refresh;
    end;
  finally
   p.free;
  end;

  fboard.Canvas.Pen.Color := flinecolor;
  if fdrawvt then
  for i := 0 to ColCount-1 do
   begin
    fboard.canvas.MoveTo( ((colwidth+2)*i)-1,0);
    fboard.canvas.lineto(((colwidth+2)*i)-1,fboard.height);
   end;
  if fdrawhz then
  for i:=0 to Rowcount -1 do
   begin
    fboard.canvas.Moveto( 0, ((rowheight+2)*i)-1);
    fboard.canvas.lineto( fboard.width, ((rowheight+2)*i)-1);
   end;

  fMustSave := true;
  flastloaddir := copy(GetCurrentpath,1,length(getcurrentpath)-1);

  image1.parent := Scrollbox1;
  image1.Width := fboard.width;
  image1.Height:= fboard.height;
  image1.Picture.Bitmap.Assign(Fboard);
  Image1.ControlStyle := Image1.ControlStyle + [csopaque];
  Scrollbox1.ControlStyle := Scrollbox1.ControlStyle + [csOpaque];
  Scrollbox1.HorzScrollBar.Range := fboard.Width;
  Scrollbox1.VertScrollBar.Range := fboard.height;
  ClearScrollBox;
  flastidx:=-1;
  Label1.caption:='';
  label2.caption:='';
  BitBtn1.Glyph:=nil;
  SpeedButton1.Glyph:=nil;
  SpeedButton2.Glyph:=nil;
  SpeedButton3.Glyph:=nil;
 finally
  screen.cursor := crdefault;
  f.release;
 end;
end;

//-----------------------------------------------------------
// SetColCount
//-----------------------------------------------------------
Procedure TFODGEMain.SetColCount(value:integer);
begin
 if value<>fcolcount then
  begin
   fcolcount := value;
   Refreshgraph;
  end;
end;

//-----------------------------------------------------------
// GetColCount
//-----------------------------------------------------------
Function TFODGEMain.GetColCount:Integer;
begin
result := fcolcount;
end;

//-----------------------------------------------------------
// SetRowCount
//-----------------------------------------------------------
Procedure TFODGEMain.SetRowCount(value:integer);
begin
 if value <> fRowcount then
  begin
   fRowCount := value;
   Refreshgraph;
  end;
end;

//-----------------------------------------------------------
// GetRowCount
//-----------------------------------------------------------
Function TFODGEMain.GetRowCount:integer;
var p:tpoint;
begin
 p:=GetCRForIndex(Listbox1.Items.Count-1);
 Result := p.y+1;
end;

//-----------------------------------------------------------
// getCellCount
//-----------------------------------------------------------
Function TFODGEMain.getCellCount:integer;
begin
 result := RowCount*ColCount;
end;

//-----------------------------------------------------------
// SetRowHeight
//-----------------------------------------------------------
procedure TFODGEMain.SetRowHeight(value:integer);
begin
 if value <> fRowheight then
  begin
   fRowHeight:=value;
   RefreshGraph;
  end;
end;

//-----------------------------------------------------------
// SetColWidth
//-----------------------------------------------------------
Procedure TFODGEMain.SetColWidth(value:integer);
begin
 if value<>fColWidth then
  begin
   fColWidth:=value;
   RefreshGraph;
  end;
end;

//-----------------------------------------------------------
// getRowHeight
//-----------------------------------------------------------
function TFODGEMain.getRowHeight:integer;
begin
 result:=fRowHeight;
end;

//-----------------------------------------------------------
// getColWidth
//-----------------------------------------------------------
function TFODGEMain.getColWidth:integer;
begin
 result := fColWidth;
end;

//-----------------------------------------------------------
// GetIndexForCR : returns linear index for Col and Row
//-----------------------------------------------------------
Function TFODGEMain.GetIndexForCR(Col,Row:integer):Integer;
begin
 Result := (Row * ColCount) + Col;
end;

//------------------------------------------------------------
// GetCRForIndex : uses a tricky Tpoint to return cell Col/Row
//                 from a linear index
//------------------------------------------------------------
Function TFODGEMain.GetCRForIndex(Idx:integer):TPoint;
Begin
 Result.y := (Idx Div ColCount);
 Result.x := (Idx Mod ColCount);
End;

//-----------------------------------------------------------
// GetCurrentpath : returns current path correctly formated
//-----------------------------------------------------------
Function TFODGEMain.GetCurrentpath:String;
begin
Application.Processmessages;
Result:=DirectoryListbox1.Directory;
if Result='' then exit;
if Result[length(Result)]<>'\' then Result:=Result+'\';
end;

//-----------------------------------------------------------
// SetType : set type of graph allowed (bmp, ico...)
//-----------------------------------------------------------
Procedure TFODGEMain.SetType(value:todgeGtype);
begin
 if value <> ftype then
  begin
   ftype:=value;
   case ftype of
    odge_Picture: myff1.FileMask := '*.bmp;*.ico;*.wmf';
    odge_Icon: myff1.FileMask := '*.ico';
    odge_Bitmap: myff1.FileMask := '*.bmp;*.wmf';
   end;
  end;
end;

//-----------------------------------------------------------
// MyFF1AddFile : Folder scanner event when a file is found
//-----------------------------------------------------------
procedure TFODGEMain.MyFF1AddFile(path: String; data: TWin32FindDataA;
  var cancel: Boolean);
begin
Listbox1.items.add(data.cFileName);
end;

//------------------------------------------------------------
// Firstpart : Returns 1st part of a string-> "1stpart=2dpart"
//------------------------------------------------------------
Function Firstpart(const s:string):string;
var p:integer;
begin
 p := pos('=',s);
 if p>0 then result := copy(s,1,p-1) else result:='';
end;

//------------------------------------------------------------
// Secondpart : Returns 2d part of a string-> "1stpart=2dpart"
//------------------------------------------------------------
Function Secondpart(const s:string):string;
var p:integer;
begin
 p:=pos('=',s);
 if p>0 then result := copy(s,p+1,length(s)) else result:='';
end;

//-----------------------------------------------------------
// LoadRegistry : load options from registry
//-----------------------------------------------------------
Procedure TFODGEMain.LoadImgRegistry;
Var reg:TRegIniFile; ii,i:integer;
begin
 reg := TregIniFile.create(Softkey);
 try
  fQuickMode := reg.ReadBool('QUICKMODE','ACTIVE',true);
  ColWidth := reg.ReadInteger('GRID','COLWIDTH',32);
  RowHeight := reg.ReadInteger('GRID','ROWHEIGHT',32);
  ColCount := reg.Readinteger('GRID','COLCOUNT',10);
  DrawHz := reg.ReadBool('GRID','DRAWHZ',true);
  Drawvt := reg.Readbool('GRID','DRAWVT',true);
  fpix := TPixelFormat(reg.ReadInteger('GRID','PIXELFORMAT',ord(pf4bit) ));
  LineColor := StringToColor( reg.ReadString('GRID','LINECOLOR','clBlack') );
  fcopythr := Reg.ReadInteger('GRID','COPYTHRESHOLD',32);
  fcopystretch := Reg.ReadBool('GRID','COPYSTRETCH',false);
  fnegfoc := reg.ReadBool('LAYOUT','NEGFOCUS',true);
 finally reg.Free; end;
end;


//-----------------------------------------------------------
// FormCreate : INIT
//-----------------------------------------------------------
procedure TFODGEMain.FormCreate(Sender: TObject);
Var reg:TRegIniFile; ii,i:integer;
begin
Image1.ControlStyle := Image1.ControlStyle + [csopaque];
Scrollbox1.ControlStyle := Scrollbox1.ControlStyle + [csOpaque];
Fboard:=Tbitmap.Create;
fColCount := 10;
fRowHeight := 32;
fColWidth := 32;
frowcount :=0;
fdrawvt:=true;
fdrawhz:=true;
ffocused:=false;
fcopythr := 32;
flinecolor:=clsilver;
ffocuscolor:=clwhite;
fnegfoc:=true;
fcopystretch:=false;
GraphType := odge_picture;
fQuickPath:=TStringlist.Create;
fCreating := true;
fpix := pf4bit; // default bitmap pixel format : 16 colors
try
 reg := TregIniFile.create(Softkey);
 try
  DriveCombobox1.Drive := reg.ReadString('CURPATH','DRIVE','C')[1];
  Application.ProcessMessages;
  DirectoryListbox1.Directory := reg.ReadString('CURPATH','PATH','');
  Application.ProcessMessages;
  Panel2.width := Reg.ReadInteger('LAYOUT','PANEL2',panel2.width);
  DirectoryListbox1.Height := Reg.ReadInteger('LAYOUT','DIRECTORY',DirectoryListbox1.Height);
  fcounter := reg.ReadInteger('LAYOUT','USECOUNT',1);
  fpicEditor := reg.ReadString('GENERIC','PICTUREEDITOR','');
  fpagefile := reg.ReadString('GENERIC','PAGEFILE','ODGEPAGE.ODP');
  BlinkingFocus := reg.ReadBool('GENERIC','BLINKFOCUS',true);
  BlinkingRate := reg.ReadInteger('GENERIC','BLINKRATE',200);
  Application.ProcessMessages;
  ii := reg.Readinteger('QUICKPATH','STRNUM',0);
  for i:=0 to ii-1 do
   fQuickPath.Add( reg.ReadString('QUICKPATH','STR'+inttostr(i),'') );
  Application.ProcessMessages;
 finally reg.Free; end;
 LoadImgRegistry;
 LoadCb1;
 synchrocb1;
finally fcreating := false; end;
DirectoryListBox1Change(nil);
end;

//-----------------------------------------------------------
// FormDestroy : Good bye...
//-----------------------------------------------------------
procedure TFODGEMain.FormDestroy(Sender: TObject);
var reg:TreginiFile; i:integer;
begin
reg:=TRegIniFile.Create(Softkey);
try
 reg.WriteString('CURPATH','DRIVE',DriveCombobox1.Drive+'');
 reg.WriteString('CURPATH','PATH',DirectoryListBox1.Directory);
 reg.WriteInteger('GRID','COLWIDTH',ColWidth);
 reg.WriteInteger('GRID','ROWHEIGHT',RowHeight);
 reg.WriteInteger('GRID','COLCOUNT',ColCount);
 reg.WriteBool('GRID','DRAWHZ',DrawHz);
 reg.WriteBool('GRID','DRAWVT',Drawvt);
 reg.WriteString('GRID','LINECOLOR', ColorToString(LineColor) );
 reg.Writeinteger('QUICKPATH','STRNUM',fQuickpath.Count);
 reg.WriteInteger('GRID','PIXELFORMAT',ord(fpix) );
 reg.WriteInteger('GRID','COPYTHRESHOLD',fcopythr);
 reg.WriteBool('GRID','COPYSTRETCH',fcopystretch);
 reg.WriteInteger('LAYOUT','PANEL2',panel2.width);
 reg.WriteInteger('LAYOUT','DIRECTORY',DirectoryListbox1.Height);
 reg.WriteString('GENERIC','PICTUREEDITOR',fpiceditor);
 reg.WriteString('GENERIC','PAGEFILE',fPageFile);
 reg.WriteBool('GENERIC','BLINKFOCUS',BlinkingFocus);
 reg.WriteInteger('GENERIC','BLINKRATE',BlinkingRate);
 inc(fcounter);
 reg.WriteInteger('LAYOUT','USECOUNT',fcounter);
 for i:=0 to fQuickpath.count-1 do
  reg.WriteString('QUICKPATH','STR'+inttostr(i),fQuickpath[i]);
 reg.WriteBool('QUICKMODE','ACTIVE',fquickmode);
 reg.WriteBool('LAYOUT','NEGFOCUS',fnegfoc);
finally reg.free; end;
FBoard.free;
fQuickPath.free;
end;

//-----------------------------------------------------------
// LoadCb1 : loads Quick Path combo items
//-----------------------------------------------------------
procedure TFODGEMain.LoadCb1;
var i:integer;
begin
 Application.ProcessMessages;
 cb1.Items.clear;
 fquickpath.sorted:=true;
 for i:=0 to fquickpath.count-1 do
  cb1.Items.add( firstpart(fquickpath[i]) );
end;

//-----------------------------------------------------------
// SynchroCb1 : syncs Quick Path combo
//-----------------------------------------------------------
procedure TFODGEMain.SynchroCb1;
var i:integer;
begin
 Application.ProcessMessages;
 for i:=0 to fquickpath.count-1 do
  if pos(Ansiuppercase(DirectoryListbox1.Directory),AnsiUppercase(fquickpath[i]))>0 then
   begin
    cb1.text := Firstpart(fquickpath[i]); break;
   end;
end;

//-----------------------------------------------------------
// DirectoryListBox1Change : Scans folder
//-----------------------------------------------------------
procedure TFODGEMain.DirectoryListBox1Change(Sender: TObject);
begin
if fcreating then exit;
if fQuickMode then SaveCurrentPage;
Updating:=true;
try
Listbox1.items.clear;
Myff1.Attributes := faanyfile;
Myff1.MinFileSize:=0;
Myff1.MaxFileSize:=maxint;
Myff1.FirstTime:=0;
Myff1.LastTime:=maxint;
Listbox1.Items.BeginUpdate;
try
 MyFF1.Find(CurrentPath);
finally Listbox1.Items.EndUpdate; end;
Rowcount := Listbox1.Items.count div Colcount;
if (Listbox1.Items.count mod Colcount)<>0 then
 RowCount := RowCount+1;
Finally Updating := false; end;
if not FileExists(CurrentPath+fpagefile) then LoadImgRegistry;
RefreshGraph;
end;

//-----------------------------------------------------------
// MyFF1ChDir : dummy to allow TMyFF to run... mysterious !
//-----------------------------------------------------------
procedure TFODGEMain.MyFF1ChDir(name: String; var cancel: Boolean);
begin
// this event must be implemented, else the underlying component seems not to work
end;


//-----------------------------------------------------------
// setdrawvt
//-----------------------------------------------------------
procedure TFODGEMain.setdrawvt(value:boolean);
begin
 if value<>fdrawvt then
  begin
   fdrawvt := value;
   Refreshgraph;
  end;
end;

//-----------------------------------------------------------
// setdrawhz
//-----------------------------------------------------------
procedure TFODGEMain.setdrawhz(value:boolean);
begin
 if value<>fdrawhz then
  begin
   fdrawhz := value;
   refreshgraph;
  end;
end;

//-----------------------------------------------------------
// setlinecolor
//-----------------------------------------------------------
procedure TFODGEMain.setlinecolor(value:tcolor);
begin
 if value <> flinecolor then
  begin
   flinecolor:=value;
   refreshgraph;
  end;
end;

//-----------------------------------------------------------
// dfoc : draws the focus cell in the bitmap
//-----------------------------------------------------------
procedure TFODGEMain.dfoc(r:trect);
 begin
 if fnegfoc then
  begin
   with image1.picture.bitmap.canvas do
    begin
     pen.color:=ffocuscolor;
     pen.Width := 1;
     pen.mode:=pmxor;
     rectangle(r.left,r.top,r.right,r.bottom);
    end;
  end else
  begin
   with image1.picture.bitmap.canvas do
    begin
    pen.width :=1;
    pen.color:=ffocuscolor;
    pen.mode:=pmxor;
    moveto(r.left,r.top);
    Lineto(r.right,r.top);
    lineto(r.right,r.bottom);
    lineto(r.left,r.bottom);
    lineto(r.left,r.top);
    end;
  end;
  ffocused:=not ffocused;
  if ffocused then fLastFocused:=r;
 end;


//-----------------------------------------------------------
// IoFileSize : returns size of file "filename"
//-----------------------------------------------------------
function IoFileSize(const FileName: String): LongInt;
var
  SearchRec       : TSearchRec;
begin
  if FindFirst(FileName,faAnyFile,SearchRec)=0
    then Result:=SearchRec.Size
    else Result:=0;
  SysUtils.FindClose( SearchRec );
end;

//-----------------------------------------------------------
// ListBox1Click : multiple inits when a file is selected
//-----------------------------------------------------------
procedure TFODGEMain.ListBox1Click(Sender: TObject);
var p:tpoint; r:trect; pic:tpicture;
begin
if fcreating then exit;
fokblink:=false;
if ffocused then Dfoc(fLastFocused);
if listbox1.itemindex>-1 then
 begin
  p:=GetCRForIndex(Listbox1.itemindex);
  r:=COmputeRecForIndex(Listbox1.itemindex);
  if sender=listbox1 then
   begin
    if (r.top<scrollbox1.VertScrollBar.Position) or
       (r.top>scrollbox1.VertScrollBar.Position+scrollbox1.ClientHeight)
       then scrollbox1.VertScrollBar.Position:=r.top-1;
    if (r.Left<scrollbox1.HorzScrollBar.Position) or
       (r.Left>scrollbox1.HorzScrollBar.Position+scrollbox1.ClientWidth)
       then scrollbox1.HorzScrollBar.Position:=r.left-1;
   end;
  dfoc(r);
  flastblink:=r;
  fokblink:=true;
//  Image1.Picture.Bitmap.canvas.DrawFocusRect(r);
  flastidx:=listbox1.itemindex;
  label1.caption:=Listbox1.items[listbox1.itemindex];
  pic:=Tpicture.Create;
  try
   pic.LoadFromFile(Currentpath+label1.caption);
   image2.Picture := pic;
   fLastPicWH.x:=pic.width;
   fLastPicWH.y:=pic.height;
   if (pic.Width mod pic.height)=0 then
    SpinEdit1.Value := pic.width div pic.height
    else spinedit1.value := 1;
   label2.caption:='W: '+inttostr(pic.Width)+' H: '+inttostr(pic.Height)+' ('+extractfileext(label1.caption)+')'+
   ' Fmt: '+copy(GetEnumName(TypeInfo(TPixelFormat),ord(pic.Bitmap.PixelFormat)),3,20)+' Sz: '+
   Inttostr(IoFileSize(Currentpath+label1.caption) ) + ' B';
   UpdateButtons;
  finally
   pic.free;
  end;
 end;
end;

//------------------------------------------------------------
// PointInRect : returns True if point X,Y is in rect Recttest
//------------------------------------------------------------
function PointInRect( const rectTest: TRect; X, Y: integer ): boolean;
begin
  Result := ( ( X >= rectTest.Left ) and ( X <= rectTest.Right ) and
              ( Y >= rectTest.Top ) and ( Y <= rectTest.Bottom ) );
end;

//---------------------------------------------------------------
// Image1MouseDown : Mouse click over the bitmap, simulates cells
//---------------------------------------------------------------
procedure TFODGEMain.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i,ix:integer; r:trect;
begin
 if fcreating then exit;
 ix:=-1;
 For i:=0 to Listbox1.Items.count-1
  do if PointInRect( ComputeRecForIndex(i),X,Y) then
   begin ix:=i; break; end;
 if ix=-1 then exit;
 Listbox1.ItemIndex := ix;
 Listbox1Click(nil);
end;

//-----------------------------------------------------------
// SpinEdit1Change
//-----------------------------------------------------------
procedure TFODGEMain.SpinEdit1Change(Sender: TObject);
begin
if fcreating then exit;
Bitbtn1.NumGlyphs := spinedit1.value;
SpeedButton1.NumGlyphs := spinedit1.value;
SpeedButton2.NumGlyphs := spinedit1.value;
SpeedButton3.NumGlyphs := spinedit1.value;
SpeedButton4.NumGlyphs := spinedit1.value;
end;

//-----------------------------------------------------------
// BitBtn2Click : Full size view
//-----------------------------------------------------------
procedure TFODGEMain.BitBtn2Click(Sender: TObject);
var b:boolean;
begin
 b:=fokblink;
 fokblink:=false;
 if ffocused then Dfoc(fLastFocused);
 with tfodgefullsize.Create(self) do
  try
   caption := currentpath+label1.caption;
   label1.Caption := self.label2.caption;
//   Image1.Picture.LoadFromFile(currentpath+self.label1.caption);
     image1.picture.assign(Image2.picture);
   showmodal;
  finally
   release;
  end;
 fokblink:=b;
end;

//-----------------------------------------------------------
// CheckBox1Click : Stretches selected image
//-----------------------------------------------------------
procedure TFODGEMain.CheckBox1Click(Sender: TObject);
begin
image2.Stretch := checkbox1.Checked;
end;

//-----------------------------------------------------------
// SpeedButton9Click : Clears selected image
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton9Click(Sender: TObject);
begin
Image2.Picture := nil;
label1.Caption:='';
label2.Caption:='';
end;

//-----------------------------------------------------------
// SpeedButton15Click : EXIT - CANCEL
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton15Click(Sender: TObject);
begin
Modalresult := mrCancel;
end;

//-----------------------------------------------------------
// SpeedButton16Click : EXIT - OK
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton16Click(Sender: TObject);
begin
ModalResult := mrOk;
end;

//-----------------------------------------------------------
// SpeedButton5Click : Copy selected image to clipboard
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton5Click(Sender: TObject);
begin
Clipboard.Assign(Image2.Picture);
end;

//-------------------------------------------------------------
// SpeedButton6Click : Paste from Clipboard into selected image
//-------------------------------------------------------------
procedure TFODGEMain.SpeedButton6Click(Sender: TObject);
var imgt : string;
begin
Image2.Picture := nil;
Image2.Picture.Assign(Clipboard);
Label1.caption := 'CLIPBOARD';
imgt:='???';
if image2.Picture.Graphic is Tbitmap then imgt:='BMP';
if image2.Picture.Graphic is TMetafile then imgt:='WMF';
if image2.Picture.Graphic is TIcon then imgt:='ICO';
label2.caption:='W: '+inttostr(image2.Picture.Width)+' H: '+inttostr(image2.picture.Height)+' ('+imgt+')'+
   ' Fmt: '+copy(GetEnumName(TypeInfo(TPixelFormat),ord(Image2.Picture.Bitmap.PixelFormat)),3,20);
end;

//-----------------------------------------------------------
// SpeedButton10Click : Adds a new Quick Path
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton10Click(Sender: TObject);
var s:string; b:boolean;
begin
 b:=fokblink;
 fokblink:=false;
 if ffocused then Dfoc(fLastFocused);
 s:='';
 InputQuery('Add a new Quick Path','shortcut name:',s);
 if s<>'' then
  begin
   fquickpath.add(s+'='+Directorylistbox1.Directory);
   Loadcb1;
   SynchroCb1;
  end;
 fokblink:=b;
end;

//-----------------------------------------------------------
// SpeedButton11Click : Deletes current Quick Path
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton11Click(Sender: TObject);
var i:integer; b:boolean;
begin
 b:=fokblink;
 fokblink:=false;
 if ffocused then Dfoc(fLastFocused);
 If Application.MessageBox('Delete current Quick Path entry ?',
        'Warning !', 292) = ID_NO Then exit;
 for i := 0 to fquickpath.count-1 do
  if AnsiComparetext(firstpart(fquickpath[i]),cb1.Text)=0 then
   begin
    fquickpath.Delete(i);
    loadcb1;
    synchrocb1;
    break;
   end;
 fokblink:=b;
end;

//-----------------------------------------------------------
// cb1Change : Quick Path selection
//-----------------------------------------------------------
procedure TFODGEMain.cb1Change(Sender: TObject);
var i:integer; s:string;
begin
if fcreating then exit;
for i := 0 to fquickpath.count-1 do
  if AnsiComparetext(firstpart(fquickpath[i]),cb1.Text)=0 then
   begin
    s:=Secondpart(fquickpath[i]);
    if s='' then exit;
    Drivecombobox1.Drive:=s[1];
    DirectoryListbox1.Directory := s;
    break;
   end;
end;

//-----------------------------------------------------------
// CutEvents : disables controls (avoiding endless calls loop)
//-----------------------------------------------------------
Procedure TFODGEMain.CutEvents;
begin
 cb1.enabled:=false;
 Drivecombobox1.Enabled:=false;
 DirectoryListBox1.Enabled:=false;
 Listbox1.Enabled :=false;
end;

//-----------------------------------------------------------
// RecoverEvents : enabled previsously disabled controls
//-----------------------------------------------------------
Procedure TFODGEMain.RecoverEvents;
begin
 cb1.enabled:=true;
 Drivecombobox1.Enabled:=true;
 DirectoryListBox1.Enabled:=true;
 Listbox1.Enabled :=true;
end;

//-----------------------------------------------------------
// SaveCurrentPage : Creates "ODGEPAGE.ODP" file
//-----------------------------------------------------------
Procedure TFODGEMain.SaveCurrentPage;
var io : TinternalObject;
begin
 if fcreating then exit;
 if not fmustsave then exit;
 if Listbox1.Items.count=0 then exit;
 fokblink:=false;
 if ffocused then Dfoc(fLastFocused);
 io := TinternalObject.Create(self);
 try
  io.Image.Assign(Image1.picture);
  io.Filelist := Listbox1.Items;
  io.ColWidth := Colwidth;
  io.RowHeight := Rowheight;
  io.ColCount := Colcount;
  io.DrawHz := drawhz;
  io.drawVt := drawvt;
  io.Linecolor := linecolor;
  io.Directory := fLastLoadDir;
  io.PixelF := fpix;
  io.CopyStretch := fcopystretch;
  io.COpyThreshold := fcopythr;
  WriteComponentResFile(flastloaddir+'\'+fpagefile,io); // COOL NO ?
  fmustsave:=false;
 finally io.free; end;
end;

//-----------------------------------------------------------
// LoadCurrentpage : Tries to load "ODGEPAGE.ODP"
//-----------------------------------------------------------
Function TFODGEMain.LoadCurrentpage:boolean;
var io : TinternalObject; i:integer; flag:boolean;
begin
 Result := false;
 if fcreating then exit;
 fokblink:=false;
 io := TInternalObject.Create(self);
 try
  try
  ReadComponentResFile(Currentpath+fpagefile,io); // Can you find simpler ?
  except
   exit;
  end;
  if (Io.Image.Width = 0) or (io.Image.Height=0) or (io.filelist.count=0) then
   begin result:=false; exit; end;
  Result := true;
  CutEvents;
  try
   DriveCombobox1.Drive := io.directory[1];
   DirectoryListbox1.Directory :=io.directory;
   fcolwidth := io.ColWidth;
   frowheight := io.RowHeight;
   fcolcount := io.colcount;
   fdrawhz := io.DrawHz;
   fdrawvt := io.drawVt;
   flinecolor := io.lineColor;
   fpix := io.PixelF;
   fcopythr := io.COpyThreshold;
   fcopystretch := io.CopyStretch;

   // check folder modifications
   Myff1.Attributes := faanyfile;
   Myff1.MinFileSize:=0;
   Myff1.MaxFileSize:=maxint;
   Myff1.FirstTime:=0;
   Myff1.LastTime:=maxint;
   Listbox1.Items.BeginUpdate;
   Listbox1.Items.clear;
   try
    MyFF1.Find(CurrentPath);
   finally Listbox1.Items.EndUpdate; end;

   if Listbox1.items.count<>io.FileList.count then
    begin
     Result:=false;
     exit;
    end;

   Listbox1.Sorted:=true;
   Tstringlist(io.FileList).Sorted:=true;
   flag:=false;
   for i:=0 to listbox1.items.count-1 do
    if AnsiComparetext(Listbox1.items[i],io.FileList[i])<>0 then
     begin
      flag:=true;
      break;
     end;

   if flag then begin result:=false; exit; end;

   Image1.Picture.Assign(io.Image);

   Scrollbox1.HorzScrollBar.Range := Image1.picture.Width;
   Scrollbox1.VertScrollBar.Range := image1.picture.height;
   Scrollbox1.HorzScrollBar.Position := 0;
   Scrollbox1.VertScrollBar.Position := 0;
   ClearScrollbox;

   ffocused := false;

  finally RecoverEvents; end;
 finally io.free; end;
Image1.ControlStyle := Image1.ControlStyle + [csopaque];
Scrollbox1.ControlStyle := Scrollbox1.ControlStyle + [csOpaque];
Application.ProcessMessages;
synchrocb1;
end;

//-----------------------------------------------------------
// SpeedButton12Click : Calls Quick Path editor window
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton12Click(Sender: TObject);
var s:string; b:boolean;
begin
 b:=fokblink;
 fokblink:=false;
 if ffocused then Dfoc(fLastFocused);
 s:=cb1.text;
 EditQuickpaths( fquickpath );
 cb1.enabled:=false;
 Loadcb1;
 if cb1.Items.IndexOf(s)>0 then
  cb1.Text := s else cb1.text:='';
 cb1.enabled:=true;
 fokblink:=b;
end;

//-----------------------------------------------------------
// SpeedButton13Click : Calls options dialog
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton13Click(Sender: TObject);
var b:boolean;
begin
 b:=fokblink;
 fokblink:=false;
if ffocused then Dfoc(fLastFocused);
FodgeOptions := TFodgeOptions.Create(self);
try
 with fodgeoptions do
  begin
   IW := Scrollbox1.ClientWidth;
   SpinEdit1.value := ColCount;
   SpinEdit3.value := ColWidth;
   SpinEdit4.value := RowHeight;
   SpinEdit2.value := fcopythr;
   CheckBox1.checked := DrawHz;
   CheckBox2.checked := Drawvt;
   shape1.Brush.color := LineColor;
   with Combobox1.Items do
    begin
     clear;
     add('Device');
     add('1 bit');
     add('4 bit');
     add('8 bit');
     add('15 bit');
     add('16 bit');
     add('24 bit');
     add('32 bit');
    end;
   Combobox1.itemindex := Ord(fpix);
   CheckBox3.checked:=fquickmode;
   CheckBox4.checked := fcopystretch;
   CheckBox5.Checked := fNegFoc;
   checkbox6.checked := Blinkingfocus;
   edit2.text:=fpagefile;
   edit1.text:=fpiceditor;
   SpinEdit5.Value := BlinkingRate;
  if Showmodal=mrOk then
   begin
    Updating := true;
    try
     ColCount := SpinEdit1.value;
     ColWidth := SpinEdit3.value;
     Rowheight := SpinEdit4.value;
     DrawHz := checkbox1.checked;
     DrawVt := checkbox2.checked;
     LineColor := Shape1.brush.color;
     fpix := TpixelFormat( Combobox1.ItemIndex) ;
     fQuickMode := Checkbox3.checked;
     fcopythr := spinedit2.value;
     fcopystretch:=checkbox4.checked;
     fNegFoc := Checkbox5.checked;
     fpiceditor:=edit1.text;
     fpagefile:=edit2.text;
     BlinkingFocus := CheckBox6.checked;
     BlinkingRate := SpinEdit5.value;
    finally Updating:=false; end;
   end;
  end;
finally fodgeoptions.Release; end;
fokblink:=b;
end;

//-----------------------------------------------------------
// Refresh1Click : Image popup -> force refresh. usefull if
//                 options are changed.
//-----------------------------------------------------------
procedure TFODGEMain.Refresh1Click(Sender: TObject);
begin
fokblink:=false;
if ffocused then Dfoc(fLastFocused);
DeleteFile(Currentpath+fpagefile);
RefreshGraph;
end;

//-----------------------------------------------------------
// FormCloseQuery : Tries to save current page when exiting
//-----------------------------------------------------------
procedure TFODGEMain.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
if fQuickMode then SaveCurrentPage;
end;

//-----------------------------------------------------------
// REGISTER PROPERTY EDITOR
//-----------------------------------------------------------
Procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(TPicture), nil, '', TODGEProperty);
  RegisterPropertyEditor(TypeInfo(TBitmap), nil, '', TODGEProperty);
  RegisterPropertyEditor(TypeInfo(TIcon), nil, '', TODGEProperty);
end;

//-----------------------------------------------------------
// SpeedButton8Click : Loads an image from disk (dialog)
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton8Click(Sender: TObject);
begin
if opd1.Execute then
 begin
  image2.Picture.LoadFromFile(opd1.FileName) ;
  label1.caption:=Extractfilename(opd1.Filename);
  label2.caption:='W: '+inttostr(image2.picture.Width)+' H: '+inttostr(image2.picture.Height)+
                  ' ('+extractfileext(label1.caption)+')'+
   ' Fmt: '+copy(GetEnumName(TypeInfo(TPixelFormat),ord(image2.picture.Bitmap.PixelFormat)),3,20)+' Sz: '+
   Inttostr(IoFileSize(opd1.Filename) ) + ' B';
  opd1.InitialDir := extractfilepath(opd1.filename);
  spd1.InitialDir := extractfilepath(opd1.filename);
  spd1.FileName := opd1.filename;
 end;
end;

//-----------------------------------------------------------
// SpeedButton7Click : Saves current image to disk (dialog)
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton7Click(Sender: TObject);
begin
If Spd1.Execute then
 begin
  Image2.Picture.SaveToFile(spd1.filename);
  opd1.InitialDir := extractfilepath(spd1.filename);
  opd1.filename := spd1.filename;
 end;
end;

//-----------------------------------------------------------
// SpeedButton14Click : Shows ABOUT BOX: DO NOT SUPPRESS !
//-----------------------------------------------------------
procedure TFODGEMain.SpeedButton14Click(Sender: TObject);
begin
 with TFODGEAbout.create(self) do
  try
   label4.caption := 'ODGE use counter : '+inttostr(fcounter);
   showmodal;
  finally release; end;
end;

//----------------------------------------------------------------
// Filecount1Click : File list popup : shows how much file in list
//----------------------------------------------------------------
procedure TFODGEMain.Filecount1Click(Sender: TObject);
begin
Showmessage(inttostr(listbox1.items.count)+' Files in this folder.');
end;

//-----------------------------------------------------------
// PopupMenu3Popup : selected image popup init
//-----------------------------------------------------------
procedure TFODGEMain.PopupMenu3Popup(Sender: TObject);
var i,ii:integer;
begin
 ii:=Integer(Image2.Picture.Bitmap.PixelFormat);
 for i:=0 to ComponentCount-1 do
  if (components[i] is TmenuItem) and
     (TmenuItem(components[i]).Tag>=1000) and (TmenuItem(components[i]).Tag<=1008)
   then
    tmenuitem(components[i]).Checked := (TmenuItem(components[i]).Tag-1000)=ii;
  EditImage1.Enabled := (fpiceditor<>'') and FileExists(fpiceditor); 
end;

//-----------------------------------------------------------
// PxiFmtChange : Pixel format change for selected image
//-----------------------------------------------------------
procedure TFODGEMain.PxiFmtChange(Sender: TObject);
var imgt:string;
begin
Image2.Picture.Bitmap.PixelFormat :=TPixelFormat(TmenuItem(Sender).tag-1000);
if image2.Picture.Graphic is Tbitmap then imgt:='BMP';
if image2.Picture.Graphic is TMetafile then imgt:='WMF';
if image2.Picture.Graphic is TIcon then imgt:='ICO';
label2.caption:='W: '+inttostr(image2.Picture.Width)+' H: '+inttostr(image2.picture.Height)+' ('+imgt+')'+
   ' Fmt: '+copy(GetEnumName(TypeInfo(TPixelFormat),ord(Image2.Picture.Bitmap.PixelFormat)),3,20);
UpdateButtons;   
end;

//-----------------------------------------------------------
// WinExecAndWait32 : as its name says it...
//-----------------------------------------------------------
function WinExecAndWait32(FileName:String; Visibility : integer):integer;
 { returns -1 if the Exec failed, otherwise returns the process' exit
   code when the process terminates }
 var
   zAppName:array[0..512] of char;
   zCurDir:array[0..255] of char;
   WorkDir:String;
   StartupInfo:TStartupInfo;
   ProcessInfo:TProcessInformation;
 begin
   StrPCopy(zAppName,FileName);
   GetDir(0,WorkDir);
   StrPCopy(zCurDir,WorkDir);
   FillChar(StartupInfo,Sizeof(StartupInfo),#0);
   StartupInfo.cb := Sizeof(StartupInfo);
   StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
   StartupInfo.wShowWindow := Visibility;
   if not CreateProcess(nil,
     zAppName,                      { pointer to command line string }
     nil,                           { pointer to process security attributes }
     nil,                           { pointer to thread security attributes }
     false,                         { handle inheritance flag }
     CREATE_NEW_CONSOLE or          { creation flags }
     NORMAL_PRIORITY_CLASS,
     nil,                           { pointer to new environment block }
     nil,                           { pointer to current directory name }
     StartupInfo,                   { pointer to STARTUPINFO }
     ProcessInfo) then              { pointer to PROCESS_INF }
      Result := -1
   else
      begin
      WaitforSingleObject(ProcessInfo.hProcess,INFINITE);
      GetExitCodeProcess(ProcessInfo.hProcess,Result);
      end;
 end;


//-----------------------------------------------------------
// EditImage1Click : Calls Image Editor for selected image
//-----------------------------------------------------------
procedure TFODGEMain.EditImage1Click(Sender: TObject);
var origCrc,NewCrc : Integer;
begin
if listbox1.itemindex<0 then
 raise exception.create('No image selected !');
OrigCrc := getCrc32ForFile(currentpath+listbox1.items[listbox1.itemindex]);
WinExecAndWait32(fpiceditor+' '+currentpath+listbox1.items[listbox1.itemindex],sw_shownormal);
NewCrc := getCrc32ForFile(currentpath+listbox1.items[listbox1.itemindex]);
if NewCrc<>origCrc then
 begin
 showmessage('You changed the image, don''t forget to refresh image list'+#13+
             'to make it reflecting modifications...');
 Listbox1Click(nil);
 end;
UpdateButtons; 
end;

//-----------------------------------------------------------
// FormShow : display edited image type
//-----------------------------------------------------------
procedure TFODGEMain.FormShow(Sender: TObject);
begin
case GraphType of
odge_none : caption:=caption+' [NO IMAGE TYPE !]';
odge_Picture : caption:=caption+' [Editing TPicture]';
odge_Icon : caption:=caption+' [Editing TIcon]';
odge_Bitmap : caption := caption+' [Editing TBitmap]';
end;
end;

//-----------------------------------------------------------
// Timer1Timer : blinking focused cell
//-----------------------------------------------------------
procedure TFODGEMain.Timer1Timer(Sender: TObject);
begin
inc(fpause); if (fpause mod 2)=0 then
 begin
  fpause :=0;
  if fOkBlink then Dfoc(fLastBlink);
 end;
end;

//-----------------------------------------------------------
// ClearScrollBox :
//-----------------------------------------------------------
procedure TFODGEMain.ClearScrollBox;
var m:timage; v,h:integer;
begin
 m:=timage.create(self);
 try
  m.parent:=scrollbox1;
  m.left:=0;
  m.top:=0;
  v:=Scrollbox1.VertScrollBar.Range;
  Scrollbox1.VertScrollBar.Range:=Scrollbox1.height;
  h:=Scrollbox1.HorzScrollBar.Range;
  Scrollbox1.HorzScrollBar.Range:=Scrollbox1.Width;
  m.width:=scrollbox1.ClientWidth;
  m.height := scrollbox1.ClientHeight;
  m.canvas.Brush.color := scrollbox1.Color;
  m.canvas.FillRect(rect(0,0,m.width,m.height));
 finally
  m.free;
  Scrollbox1.VertScrollBar.Range:=v;
  Scrollbox1.HorzScrollBar.Range:=h;
 end;
end;

Procedure Convert2Gray(Cnv: TCanvas);
Var X, Y: Integer;
    Color: LongInt;
    R, G, B,
    Gr: Byte;
Begin
  With Cnv Do
   For X := Cliprect.Left To ClipRect.Right Do
    For Y := Cliprect.Top To ClipRect.Bottom Do
    begin
     Color := ColorToRGB(Pixels[X,Y]);
     B := (Color And $FF0000) Shr 16;
     G := (Color And $FF00) Shr 8;
     R := (Color And $FF);
     Gr:= HiByte(R*77+G*151+B*28);
(*     GR := Trunc(B*0.11+G*0.59+R*0.3);*)
     Pixels[X,Y] := RGB(Gr,Gr,Gr);
    End;

End;

Function RGB(R,G,B: Byte): TColor;
Begin
  Result := B Shl 16 Or
            G Shl 8  Or
            R;
End;

//-----------------------------------------------------------
// Converttogray1Click : convert image to gray
//-----------------------------------------------------------
procedure TFODGEMain.Converttogray1Click(Sender: TObject);
begin
 screen.Cursor := crHourGlass;
 try
 Convert2Gray(Image2.Canvas);
 finally Screen.cursor := crdefault; end;
 UpdateButtons;
end;

//-----------------------------------------------------------
// UpdateButtons : update simulation area;
//-----------------------------------------------------------
Procedure TFODGEMain.UpdateButtons;
begin
   panel4.visible:=false;
   BitBtn1.NumGlyphs := spinedit1.value;
   if (fLastPicWH.y<bitbtn1.height) then Bitbtn1.Glyph := Image2.Picture.Bitmap else panel4.visible:=true;
   panel5.visible:=false;
   if (fLastPicWH.y<Speedbutton1.height) then
    begin
     SpeedButton1.NumGlyphs := spinedit1.value;
     SpeedButton2.NumGlyphs := spinedit1.value;
     SpeedButton3.NumGlyphs := spinedit1.value;
     SpeedButton4.NumGlyphs := spinedit1.value;
     SpeedButton1.Glyph := Image2.picture.Bitmap;
     SpeedButton2.Glyph := Image2.picture.Bitmap;
     SpeedButton3.Glyph := Image2.picture.Bitmap;
     SpeedButton4.Glyph := Image2.picture.Bitmap;
    end else panel5.visible:=true;
end;

function sgn (a : extended) : extended;
begin
  if a < 0  then  result := -1
            else  result :=  1;
end;


procedure bmp_rotate(src,dst:tbitmap;angle:extended;neutral:tcolor);
var
  c1x,c1y,c2x,c2y:integer;
  p1x,p1y,p2x,p2y:integer;
  radius,n:integer;
  alpha:extended;
  c0,c1,c2,c3:tcolor;

begin
     //calculate the angle to pi-format
     angle := DegToRad(Angle); {(angle / 180) * pi;}

     // calculate the central points
     c1x := src.width div 2;
     c1y := src.height div 2;
     c2x := dst.width div 2;
     c2y := dst.height div 2;

     // number of steps
     if c2x < c2y then n := c2y else n := c2x;
     dec (n,1);

     // starting rotation
     for p2x := 0 to n do begin
         for p2y := 0 to n do begin
             if p2x = 0 then alpha:= pi/2 else
                alpha := arctan2(p2y,p2x);
             radius := round(sqrt((p2x*p2x)+(p2y*p2y)));
             p1x := round(radius * cos(angle+alpha));
             p1y := round(radius * sin(angle+alpha));

             if ((c1x+p1x)>src.width) or ((c1y+p1y)>src.Height) or
                ((c1x+p1x)<0) or ((c1y+p1y)<0) 
               then c0:=neutral else c0 := src.canvas.pixels[c1x+p1x,c1y+p1y];
             if ((c1x-p1x)>src.width) or ((c1y-p1y)>src.Height) or
                ((c1x-p1x)<0) or ((c1y-p1y)<0)
               then c1:=neutral else c1 := src.canvas.pixels[c1x-p1x,c1y-p1y];
             if ((c1x+p1y)>src.width) or ((c1y-p1x)>src.Height) or
                ((c1x+p1y)<0) or ((c1y-p1x)<0)
               then c2:=neutral else c2 := src.canvas.pixels[c1x+p1y,c1y-p1x];
             if ((c1x-p1y)>src.width) or ((c1y+p1x)>src.Height) or
                ((c1x-p1y)<0) or ((c1y+p1x)<0)
               then c3:=neutral else c3 := src.canvas.pixels[c1x-p1y,c1y+p1x];

             dst.canvas.pixels[c2x+p2x,c2y+p2y]:=c0;
             dst.canvas.pixels[c2x-p2x,c2y-p2y]:=c1;
             dst.canvas.pixels[c2x+p2y,c2y-p2x]:=c2;
             dst.canvas.pixels[c2x-p2y,c2y+p2x]:=c3;
         end;
         application.processmessages
     end;
end;

//-----------------------------------------------------------
// Rotate1Click : rotates selected image
//-----------------------------------------------------------
procedure TFODGEMain.Rotate1Click(Sender: TObject);
var m:tpicture; angle:extended; s:string; neutral:tcolor;
    corners:array[1..4] of tpoint; x,x2,y,y2:integer;
 procedure rotate(var p:tpoint;ang:extended);
 var pp:tpoint;
 begin
  pp.x:= Round((p.x*cos(DegToRad(ang))) - (p.y*sin(DegToRad(ang))));
  pp.y:= Round((p.y*cos(DegToRad(ang))) - (p.x*sin(DegToRad(ang))));
  p:=pp;
 end;
begin
 s:='';
 if not InputQuery('Bitmap rotation', 'Angle (degrees)', s) then exit;
 try
  angle := StrToFloat(s);
 except
  on E:EConvertError do
   begin
    showmessage(s+' is not a valid float number !');
    exit;
   end;
  else raise;
 end;
 screen.Cursor := crHourGlass;
 try
  m:=Tpicture.Create;
  try
   corners[1].x:=-image2.picture.bitmap.width div 2;
   Corners[1].y:=-image2.picture.bitmap.height div 2;

   Corners[2].x:= image2.picture.bitmap.width div 2;
   Corners[2].y:= Corners[1].y;

   Corners[3].x:= Corners[1].x;
   Corners[3].y:= image2.picture.bitmap.height div 2;

   Corners[4].x:= Corners[1].x;
   Corners[4].y:= Corners[3].y;

   Rotate(Corners[1],Angle); Rotate(Corners[2],Angle);
   Rotate(Corners[3],Angle); Rotate(Corners[4],Angle);

   x:=MinIntValue([Corners[1].x,Corners[2].x,Corners[3].x,Corners[4].x]);
   x2:=MaxIntvalue([Corners[1].x,Corners[2].x,Corners[3].x,Corners[4].x]);
   y:=MinIntValue([Corners[1].y,Corners[2].y,Corners[3].y,Corners[4].y]);
   y2:=MaxIntvalue([Corners[1].y,Corners[2].y,Corners[3].y,Corners[4].y]);

   m.bitmap.Height := Abs(y2-y);
   m.bitmap.Width  := Abs(x2-x);

   neutral := Image2.Picture.Bitmap.Canvas.Pixels[0,0];
   bmp_rotate(image2.picture.Bitmap,m.Bitmap,angle,neutral);
   Image2.Picture:=m;
  finally m.free; end;
 finally Screen.cursor := crdefault; end;
 UpdateButtons;
end;

end.

