{

   Project  : ODGE
   Unit Name: uodge_options

 /--------------------------------------------------------------\
 | Purpose    : OPTIONS DIALOG                                  |
 | Author     : Olivier DAHAN 100531.163@compuserve.com         |
 +--------------------------------------------------------------+
 | History    : V 1.0                                           |
 | Created on : 16/04/98 02:10:52                               |
 \--------------------------------------------------------------/
}

unit uodge_options;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Spin;

type
  TFodgeoptions = class(TForm)
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    Shape1: TShape;
    SpeedButton1: TSpeedButton;
    ComboBox1: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    cd1: TColorDialog;
    CheckBox3: TCheckBox;
    SpinEdit2: TSpinEdit;
    Label2: TLabel;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Edit1: TEdit;
    Label7: TLabel;
    SpeedButton2: TSpeedButton;
    OpenDialog1: TOpenDialog;
    Edit2: TEdit;
    Label8: TLabel;
    CheckBox6: TCheckBox;
    SpinEdit5: TSpinEdit;
    Label9: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure SpinEdit1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpinEdit3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    IW :Integer;
  end;


var
  Fodgeoptions: TFodgeoptions;

implementation

{$R *.DFM}

procedure TFodgeoptions.SpeedButton1Click(Sender: TObject);
begin
cd1.color := SHape1.brush.color;
if cd1.execute then Shape1.brush.color := cd1.color;
end;

procedure TFodgeoptions.SpeedButton2Click(Sender: TObject);
begin
if opendialog1.Execute then edit1.Text :=opendialog1.filename;
end;

procedure TFodgeoptions.FormShow(Sender: TObject);
begin
label9.enabled:=Checkbox6.checked;
SpinEdit5.enabled := Checkbox6.checked;
end;

procedure TFodgeoptions.CheckBox6Click(Sender: TObject);
begin
label9.enabled:=Checkbox6.checked;
SpinEdit5.enabled := Checkbox6.checked;
end;

procedure TFodgeoptions.SpinEdit1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
SpinEdit1.Hint := 'Optimal : '+inttostr(IW div (SpinEdit3.Value+2));
end;

procedure TFodgeoptions.SpinEdit3MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
SpinEdit3.Hint := 'Optimal: '+inttostr((IW-(2*SpinEdit1.value)) div (SpinEdit1.Value))+#13+
                  '(this value take care of actual scroll bar display)';
end;

end.

